Name: xfs
Version: 1.0.4
%define subrel 1
Release: %mkrel 2
Summary: Font server for X11
Group: System/Servers
Source0: http://xorg.freedesktop.org/releases/individual/app/%{name}-%{version}.tar.bz2
Source1: xfs.init
Source2: xfs.config
Patch00: xorg-xfs-1.0.4-CVE-2007-4568-4990.patch
License: MIT
Packager: Gustavo Pichorim Boiko <boiko@mandriva.com>
BuildRoot: %{_tmppath}/%{name}-root

BuildRequires: libfs-devel >= 1.0.0
BuildRequires: libxfont-devel >= 1.0.0
BuildRequires: x11-util-macros >= 1.0.1
BuildRequires: x11-xtrans-devel >= 1.0.0

Requires(pre): rpm-helper 
Requires(post): rpm-helper 
#PreReq: chkfontpath
Requires: fslsfonts
Requires: fstobdf
Requires: showfont

%description
This is a font server for X11.  You can serve fonts to other X servers
remotely with this package, and the remote system will be able to use all
fonts installed on the font server, even if they are not installed on the
remote computer.

%prep
%setup -q -n %{name}-%{version}
%patch00 -p1 -b .cve-2007-4568-4990

%build
%configure2_5x	--x-includes=%{_includedir}\
		--x-libraries=%{_libdir}

%make configdir=%{_sysconfdir}/X11/fs

%install
rm -rf %{buildroot}
%makeinstall_std configdir=%{_sysconfdir}/X11/fs

# initscript
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/xfs

# config
# remove the default
rm -f %{buildroot}%{_sysconfdir}/X11/fs/config
#install ours
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/X11/fs/config

# add backward compatibility link for /usr/X11R6/lib/X11/fs (#23423)
install -d -m 755 %{buildroot}%{_libdir}/X11/
ln -s ../../../../%{_sysconfdir}/X11/fs %{buildroot}%{_libdir}/X11/fs

%pre
%_pre_useradd xfs /etc/X11/fs /bin/false

# for msec high security levels
%_pre_groupadd xgrp xfs


%post
if [ ! -d /usr/X11R6/lib/X11 ]; then
   echo "creating /usr/X11R6/lib/X11 linked to /usr/lib/X11 for commercial applications"
   mkdir -p /usr/X11R6/lib
   ln -s ../../%{_lib}/X11 /usr/X11R6/lib/X11
elif [ ! -d /usr/X11R6/lib/X11/fs ]; then
   echo "creating /usr/X11R6/lib/X11/fs linked to /usr/lib/X11/fs for commercial applications"
   ln -s ../../../%{_lib}/X11/fs /usr/X11R6/lib/X11/fs
fi

# CHECKME: do drakfonts still exist? the dependency on chkfontpath at this point
#          is not good (as it creates a circular dependency involving PreReqs)
%if 0
# as we don't overwrite the config file, we may need to add those paths
# (2=update)
if [ "$1" -gt 1 ]; then
	for i in /usr/X11R6/lib/X11/fonts/drakfont \
			/usr/X11R6/lib/X11/fonts/pcf_drakfont:unscaled \
			/usr/X11R6/lib/X11/fonts/TTF
	do
		if ls `dirname $i`/`basename $i :unscaled`/*.* >/dev/null 2>/dev/null
		then
			if ! grep "$i" /etc/X11/fs/config >/dev/null 2>/dev/null ; then
				/usr/sbin/chkfontpath -q -a "$i"
			fi
		else
			if grep "$i" /etc/X11/fs/config >/dev/null 2>/dev/null ; then
				/usr/sbin/chkfontpath -q -r "$i"
			fi
		fi
	done
fi
%endif

%_post_service xfs

# handle init sequence change
if [ -f /etc/rc5.d/S90xfs ] && grep -q 'chkconfig: 2345 20 10' /etc/init.d/xfs; then
	/sbin/chkconfig --add xfs
fi

%preun
%_preun_service xfs
# FIXME: it can't really remove the xfs service because it is needed
#        by the dm service
true

%postun
%_postun_userdel xfs

%triggerpostun -- XFree86-xfs
%_post_service xfs
if [ ! -f /var/lock/subsys/xfs ]
then
  /sbin/service xfs start
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(-,xfs,xfs) %dir %{_sysconfdir}/X11/fs
%{_libdir}/X11/fs
%{_bindir}/xfs
%{_mandir}/man1/xfs.*
%attr(-,xfs,xfs) %config(noreplace) %{_sysconfdir}/X11/fs/config
%{_sysconfdir}/rc.d/init.d/xfs


%changelog
* Fri Nov 02 2007 Gustavo De Nardin <gustavodn@mandriva.com> 1.0.4-2.1mdv2007.1
- P00: security fix for CVE-2007-4568,4990

* Wed Mar 07 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.0.4-2mdv2007.0
+ Revision: 134425
- Remove unused old drakfont paths (#22457)
- Remove old /usr/lib/X11/fonts paths
- Add some missing drakfont paths

* Thu Dec 14 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.4-1mdv2007.1
+ Revision: 97064
- new release

  + Pixel <pixel@mandriva.com>
    - fix compatibility symlink on x86_64

* Mon Sep 18 2006 Pixel <pixel@mandriva.com> 1.0.2-12mdv2007.0
+ Revision: 61939
- do not provide nor obsolete xorg-x11-xfs which is still a package in 2007.0
- do not provide nor obsolete xorg-x11-xfs which is still a package in 2007.0
- before creating symlink ../../lib/X11 -> /usr/X11R6/lib/X11, ensure directory /usr/X11R6/lib exists

* Thu Sep 14 2006 Pixel <pixel@mandriva.com> 1.0.2-11mdv2007.0
+ Revision: 61465
- in some cases we can not symlink /usr/X11R6/lib/X11 to /usr/lib/X11 since pkg like multiarch-utils vivify it. in that case, creating symlink /usr/X11R6/lib/X11/fs to /usr/lib/X11/fs (and so /etc/X11/fs)
- creating /usr/X11R6/lib/X11 linked to /usr/lib/X11 for commercial applications (#23423)

* Wed Aug 23 2006 Antonio Hobmeir Neto <neto@mandriva.com> 1.0.2-9mdv2007.0
+ Revision: 57757
- Changed the word "Mandrake" per "Mandriva" in xfs.config (#21025)

* Mon Aug 21 2006 Pixel <pixel@mandriva.com> 1.0.2-8mdv2007.0
+ Revision: 56957
- better handle fs/config migration to /usr/share/fonts in a trigger in xorg-x11-xfs

* Thu Aug 17 2006 Pixel <pixel@mandriva.com> 1.0.2-7mdv2007.0
+ Revision: 56569
- (minor) increase release number
- fix migrating /etc/X11/fs/config directories to /usr/share/fonts

* Thu Aug 03 2006 Helio Chissini de Castro <helio@mandriva.com> 1.0.2-6mdv2007.0
+ Revision: 51500
- Added new place /usr/share/fonts. Approved by Boiko

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - when restarting xfs be sure it starts as daemon (#23240)
    - handle the restart case when there is the /var/lock/subsys/xfs file but no
      xfs running (#11717)

* Mon Jul 03 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.0.2-4mdv2007.0
+ Revision: 38331
- Upload blino's fix for #23423
- rebuild to fix cooker uploading
- X11R7.1
- Add packager tag
- Remove the X11R6 from the font paths in /etc/X11/fs/config
- fixed xfs.config file to search for fonts in the new prefix
- removed the dependency on chkfontpath as it was causing a circular dependency
  involving pre-reqs
- the preun script doesn't work if the dm service is present, just returning
  true for now
- increment release
- fixed more dependencies
- Adding X.org 7.0 to the repository

  + Olivier Blin <oblin@mandriva.com>
    - add backward compatibility link for /usr/X11R6/lib/X11/fs (#23423)

  + Pascal Terjan <pterjan@mandriva.org>
    - return exit code for status in the initscript

  + Pixel <pixel@mandriva.com>
    - /etc/init.d/xfs is not a conf file
    - don't use PreReq
    - don't use _sourcedir
    - restart xfs *after* removing X11R6/ from the config file

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

